----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    19:47:42 02/21/2014 
-- Design Name: 
-- Module Name:    add_sub - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity add_sub is
    Port ( A : in  STD_LOGIC_VECTOR (31 downto 0);
           B : in  STD_LOGIC_VECTOR (31 downto 0);
           addsub : in  STD_LOGIC;
           Output : out  STD_LOGIC_VECTOR (31 downto 0);
           Cout : out  STD_LOGIC);
end add_sub;

architecture Behavioral of add_sub is

component Summer_32
	port ( A : in  STD_LOGIC_VECTOR (31 downto 0);
           B : in  STD_LOGIC_VECTOR (31 downto 0);
           Cin : in  STD_LOGIC;
           Sum : out  STD_LOGIC_VECTOR (31 downto 0);
           Cout : out  STD_LOGIC);
end component;

signal Btemp : std_logic_vector(31 downto 0);
begin

process(B,addsub)

begin

for I in 0 to 31 loop
	Btemp(I)<=B(I) xor addsub;
end loop;

end process;

adder0: Summer_32
					port map (A=>A,
								 B=>Btemp,
								 Cin=>addsub,
								 Sum=>Output,
								 Cout=>Cout);


end Behavioral;

