----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:24:49 02/23/2014 
-- Design Name: 
-- Module Name:    circ_rotate_left - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity circ_rotate_left is
    Port ( Input : in  STD_LOGIC_VECTOR (31 downto 0);
           Output : out  STD_LOGIC_VECTOR (31 downto 0));
end circ_rotate_left;

architecture Behavioral of circ_rotate_left is

signal shift :bit_vector(31 downto 0);
signal shift_sd : std_logic_vector(31 downto 0);
begin

shift<=to_bitvector(Input) sll 1;
shift_sd<=to_stdlogicvector(shift);

Output<=shift_sd(31 downto 1) & Input(31);
end Behavioral;

