----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    19:37:21 03/10/2013 
-- Design Name: 
-- Module Name:    cladder - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity cladder is
    Port ( A : in  STD_LOGIC_VECTOR (3 downto 0);--eisodos 1ou arithmou,sw0-3
           B : in  STD_LOGIC_VECTOR (3 downto 0);--eisodos 2ou arithmou sw4-sw7
           Cin : in  STD_LOGIC;						 --eisodos carry in,btn0
           Cout : out  STD_LOGIC;					 -- carry out,led4
           Sum : out  STD_LOGIC_VECTOR (3 downto 0)); --exodos sum,led0-3
end cladder;

architecture struct3 of cladder is

component carry_gen --dilosh tou component pou vgazei ta generate k propagate simata
		port ( A : in  STD_LOGIC_VECTOR (3 downto 0);
				B : in  STD_LOGIC_VECTOR (3 downto 0);
				P : out  STD_LOGIC_VECTOR (3 downto 0);
				G : out  STD_LOGIC_VECTOR (3 downto 0)
			  );
end component;

component carry_lkahd --dilosh tou component pou paragei ta kratoumena
		port ( P : in  STD_LOGIC_VECTOR (3 downto 0);
				 G : in  STD_LOGIC_VECTOR (3 downto 0);
				 Cin : in  STD_LOGIC;
				 Cout : out  STD_LOGIC;
				 Csum : out  STD_LOGIC_VECTOR (2 downto 0) --ta kratoumena pou pernei o athroisths
			  );
end component;

component sum_unit--dilosh tou athroisth
		port ( P : in  STD_LOGIC_VECTOR (3 downto 0);
             Cins : in  STD_LOGIC_VECTOR (2 downto 0);
             Cin : in  STD_LOGIC;
             S : out  STD_LOGIC_VECTOR (3 downto 0)
			  );
end component;

signal prop,gen : std_logic_vector(3 downto 0); --"kalodia" p pane apo to ca_g instance tou carry_gen sot clkah tou carry_lkahd
signal carry	:	std_logic_vector (2 downto 0);--ta "kalodia" p pane apo to clkah instance sto adder instance tou sum_unit


begin
ca_g: carry_gen --instatiation tis mias monadas carry_gen
				port map(A=>A,--pernei eisodous apo "exo" to A
							B=>B,--...to B
							P=>prop,--vgazei sto prop to P
							G=>gen);--...kai to G sto gen
							
clkah: carry_lkahd
				port map(P=>prop,--pernei eisodo sti thyra P to sima prop
							G=>gen, --...sti G to gem
							Cin=>Cin,--to Cin apo ton exo kosmo
							Cout=>Cout,--vgazei to Cout
							Csum=>carry);--vgazei sto carry to Csum (ta kratoumena pou xreiazetai to sum_unit apo to carry_lkahd
Adder:	sum_unit
				port map(P=>prop,--pernei ta propagate simata apo to prop
							Cins=>carry,--ta 3 teleftea kratoumena apo to carry_lkahd
							Cin=>Cin, --...to proto kratoumeno apo ton exo kosmo
							S=>Sum);--vgazei to athroisma

end struct3;

