----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    00:01:34 03/09/2014 
-- Design Name: 
-- Module Name:    immed_extend - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_SIGNED.ALL;
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity immed_extend is
    Port ( instr : in  STD_LOGIC_VECTOR (15 downto 0);
           op_code : in  STD_LOGIC_VECTOR (5 downto 0);
           immed : out  STD_LOGIC_VECTOR (31 downto 0));
end immed_extend;

architecture Behavioral of immed_extend is

begin

with op_code select
				immed<=sxt(instr,32) when "110000", --sign extend
				sxt(instr,32) when "111000",--sign extend
				ext(instr,32) when "111100",--zero fill
				ext(instr,32) when "111110",--zero fill
				sxt(instr,32) when "111111",--sign extend 
				sxt(instr,32) when "000000",--sign extend
				sxt(instr,32) when "000001",--sign extend
				sxt(instr,32) when "000011",--sign extend
				sxt(instr,32) when "000111",--sign extend
				sxt(instr,32) when "001111",--sign extend
				sxt(instr,32) when "011111",--sign extend
				sxt(instr,32) when "100001",--sign extend lbB0
				sxt(instr,32) when "100111",--sign extend addmem
				ext(instr,32) when others;
end Behavioral;

