----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:49:14 03/11/2014 
-- Design Name: 
-- Module Name:    mux_alu_stage - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mux_alu_stage is
    Port ( input_rf : in  STD_LOGIC_VECTOR (31 downto 0);
           input_imm : in  STD_LOGIC_VECTOR (31 downto 0);
           slct : in  STD_LOGIC;
           mux_out : out  STD_LOGIC_VECTOR (31 downto 0));
end mux_alu_stage;

architecture Behavioral of mux_alu_stage is

begin


with slct select
	  mux_out<=input_imm when '1',
	  input_rf when '0',
	  "00000000000000000000000000000000" when others;

end Behavioral;


