----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:55:56 03/26/2014 
-- Design Name: 
-- Module Name:    CNTRL - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_unsigned.all;


-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity CNTRL is

    Port ( PC_sel : out  STD_LOGIC;
           PC_LdEn : out  STD_LOGIC;
           Clock : in  STD_LOGIC;
           Reset : in  STD_LOGIC;
           Zero : in  STD_LOGIC;
			  lt :in std_logic;-- gia to addle apo to datapath
           RF_B_sel : out  STD_LOGIC;
           RF_wr_sel : out  STD_LOGIC_VECTOR (1 downto 0);
           ALU_Bin_sel : out  STD_LOGIC;
			  ld_type_sel : out std_logic;--lbBO
			  addle_crtl  : out std_logic;--addle
			  imm_or_zero : out std_logic; --addmem
			  equal : in std_logic;--beqregmem
			  addr_sel :out std_logic_vector(1 downto 0);--..to idio
			  reg_immed : out std_logic;--to idio	

			  var_addr : out std_logic_vector(4 downto 0);--metavalei tis dieythinseis sth mnhmh
			  var_addr_act : out std_logic;--energopoiei ton polyplekth p epilegei to rb_B_out metaksy normal (rt/rd kai metavalomenhs timhs)
			  mem_var :out std_logic_vector(31 downto 0);--counter p ayksanei apo immediate k panw 
			  
          --ALU_func : outSTD_LOGIC_VECTOR (3 downto 0);
           Mem_datain_sel :out  STD_LOGIC;
           Mem_dataout_sel : out  STD_LOGIC;
           Mem_WrEn : out  STD_LOGIC;
			  instr :in std_logic_vector(31 downto 0);
           RF_WrEn : out  STD_LOGIC);
end CNTRL;







architecture Behavioral of CNTRL is

type state is (rst,dec_stage,li_state,rf0pc0,rf0,r_type1,im_type1,beq,bneq,store1,load1,sbyte1,lbyte1,lbBO1,addmem1,addmem2,addmem3,bmem1,bmem2,stregs1,stregs2);
signal fsm_state :state;

signal i :std_logic_vector(4 downto 0):="00000";
signal temp :std_logic_vector(31 downto 0);


begin

process
begin
wait until Clock'event and Clock='1';

if Reset='1' then
	PC_LdEn<='0';
	PC_sel<='0';
	RF_B_sel<='0';
	RF_wr_sel<="00";
	ALU_Bin_sel<='0';
	ld_type_sel<='0';
	addle_crtl<='0';
	imm_or_zero<='0';
	addr_sel<="00";
	reg_immed<='0';		  
	MEM_datain_sel<='0';
	MEM_dataout_sel<='0';
	MEM_WrEn<='0';
	RF_WrEn<='0';
	var_addr<="00000";
	var_addr_act<='0';
	mem_var<="00000000000000000000000000000000";
	fsm_state<=rst;
else

 if fsm_state=rst then
		PC_LdEn<='0'; --na doume an vgenoun
		PC_sel<='0';
		RF_B_sel<='0';
		RF_wr_sel<="00";
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';		
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rst;
		if Reset='1' then
			fsm_state<=rst;
		else
			fsm_state<=dec_stage;
		end if;
elsif	fsm_state=dec_stage then
	 i<=instr(31 downto 26);
	 if instr="00000000000000000000000000000000" then --nop
		PC_LdEn<='1'; 
		PC_sel<='0';
		RF_B_sel<='0';
		RF_wr_sel<="00";
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';	
		addr_sel<="00";
		reg_immed<='0';		
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0pc0;
	 elsif instr(31 downto 26)="110000" then --li
		PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='0';
		RF_wr_sel<="00";
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';	
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=li_state;
	 elsif instr(31 downto 26)="100000" then --r type
	   PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='0';
		RF_wr_sel<="00";
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';	
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=r_type1;
	 elsif instr(31 downto 26)="111000" or instr(31 downto 26)="111100" or instr(31 downto 26)="111110" then --addi/andi/ori
		PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='0';
		RF_wr_sel<="00";
		ALU_Bin_sel<='1';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';		
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=im_type1;
	 elsif instr(31 downto 26)="111111" then --b
		PC_LdEn<='1'; 
		PC_sel<='1';
		RF_B_sel<='0';
		RF_wr_sel<="00";
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';	
		addr_sel<="00";
		reg_immed<='0';	
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0pc0;
	 elsif instr(31 downto 26)="000000" then --beq
	   PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='1';
		RF_wr_sel<="00";
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';		
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=beq;
	 elsif instr(31 downto 26)="000001" then --bneq
	   PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='1';
		RF_wr_sel<="00";
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';	
		addr_sel<="00";
		reg_immed<='0';		
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=bneq;
	 elsif instr(31 downto 26)="011111" then --sw
		PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='1';
		RF_wr_sel<="00";
		ALU_Bin_sel<='1';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';		
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=store1;
	 elsif instr(31 downto 26)="001111" then --lw
	   PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='1';
		RF_wr_sel<="01";
		ALU_Bin_sel<='1';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';		
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
	   fsm_state<=load1;
	 elsif instr(31 downto 26)="000111" then --sb
		PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='1';
		RF_wr_sel<="00";
		ALU_Bin_sel<='1';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='1';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=sbyte1;
	 elsif instr(31 downto 26)="000011" then --lb
	   PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='1';
		RF_wr_sel<="01";
		ALU_Bin_sel<='1';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';		
		MEM_datain_sel<='0';
		MEM_dataout_sel<='1';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
	   fsm_state<=lbyte1;
	 elsif instr(31 downto 26)="100001" then --lbBO
		PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='1';
		RF_wr_sel<="01";
		ALU_Bin_sel<='1';
		ld_type_sel<='1';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';		
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
	   fsm_state<=lbBO1;
	 elsif instr(31 downto 26)="100011" then --addle
	   PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='1'; --diavazw apo ton rd gia afairesh
		RF_wr_sel<="00";
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='1';-- kanw afairesh
		imm_or_zero<='0';
      addr_sel<="00";
		reg_immed<='0';		
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		
		if lt='0' or zero='1' then --ginetai h aferesh metaksy RF[rs] k RF[rd] (o polyplekth rf_b sel alazei timh kata ths ektelesh ths entolhs)
			PC_LdEn<='0'; 
			PC_sel<='0';
			RF_B_sel<='0'; --diavazw apo ton rt k kanw prosthaish
			RF_wr_sel<="00";
			ALU_Bin_sel<='0';
			ld_type_sel<='0';
			addle_crtl<='0';
			imm_or_zero<='0';
			addr_sel<="00";
			reg_immed<='0';			
			MEM_datain_sel<='0';
			MEM_dataout_sel<='0';
			MEM_WrEn<='0';
			RF_WrEn<='0';
			var_addr<="00000";
			var_addr_act<='0';
			mem_var<="00000000000000000000000000000000";
			fsm_state<=r_type1;
		else
			PC_LdEn<='1'; 
			PC_sel<='0';
			RF_B_sel<='1'; --diavazw apo ton rd gia afairesh
			RF_wr_sel<="00";
			ALU_Bin_sel<='0';
			ld_type_sel<='0';
			addle_crtl<='1';-- kanw afairesh
			imm_or_zero<='0';
			addr_sel<="00";
			reg_immed<='0';			
			MEM_datain_sel<='0';
			MEM_dataout_sel<='0';
			MEM_WrEn<='0';
			RF_WrEn<='0';
			var_addr<="00000";
			var_addr_act<='0';
			mem_var<="00000000000000000000000000000000";
			fsm_state<=rf0pc0;
		end if;
    elsif instr(31 downto 26)="100111" then --addmem	
		PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='1'; --monima ston rd afou tha ton xrhsimopoihsw san endiameso (afou ekei tha grapsw to apotelesma en telei)
		RF_wr_sel<="01"; --arxika grafw ston rd oti exei mesa h thesh RF[rs]
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='1'; --zero
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=addmem1;
	 elsif instr(31 downto 26)="101111" then --beqregmem
	   PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='1'; 
		RF_wr_sel<="00"; 
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0'; 
		addr_sel<="01"; --00 kanonika alu, 01 kateythian immed,diavazw oti einai sthn MEM[immed<<2)
		reg_immed<='0';--1 register 0 immed
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=bmem1;
	 elsif instr(31 downto 26)="110111" then --store registers
		i<=instr(25 downto 21);--arxikopoihsh ton counters
		temp<="00000000000000000000000000000000";
		
		PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='0';
		RF_wr_sel<="00";
		ALU_Bin_sel<='1';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="10";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<=i;--na alaksoun!!!
		var_addr_act<='1';
		mem_var<=temp;
		
		fsm_state<=stregs1;
	 else
		fsm_state<=rst;
	 end if; --if apofashs leitourgias
elsif fsm_state=stregs1 then
		
		if (i<=instr(20 downto 16)) then --an einai mikrotero iso kanw store
			PC_LdEn<='0'; 
			PC_sel<='0';
			RF_B_sel<='0';
			RF_wr_sel<="00";
			ALU_Bin_sel<='1';
			ld_type_sel<='0';
			addle_crtl<='0';
			imm_or_zero<='0';
			addr_sel<="10";
			reg_immed<='0';
			MEM_datain_sel<='0';
			MEM_dataout_sel<='0';
			MEM_WrEn<='0';
			RF_WrEn<='0';
			var_addr<=i;--na alaksoun!!!
			var_addr_act<='1';
			mem_var<=temp;
			--temp<=temp+1;
			--i<=i+1;
			fsm_state<=stregs2;
		else
			PC_LdEn<='1'; 
			PC_sel<='0';
			RF_B_sel<='0';
			RF_wr_sel<="00";
			ALU_Bin_sel<='1';
			ld_type_sel<='0';
			addle_crtl<='0';
			imm_or_zero<='0';
			addr_sel<="10";
			reg_immed<='0';
			MEM_datain_sel<='0';
			MEM_dataout_sel<='0';
			MEM_WrEn<='0';
			RF_WrEn<='0';
			fsm_state<=rf0pc0;
		end if;
elsif fsm_state=stregs2 then
			PC_LdEn<='0'; 
			PC_sel<='0';
			RF_B_sel<='0';
			RF_wr_sel<="00";
			ALU_Bin_sel<='1';
			ld_type_sel<='0';
			addle_crtl<='0';
			imm_or_zero<='0';
			addr_sel<="10";
			reg_immed<='0';
			MEM_datain_sel<='0';
			MEM_dataout_sel<='0';
			MEM_WrEn<='1';
			RF_WrEn<='0';
			
			temp<=temp+"00000000000000000000000000000001";
			i<=i+"00001";
			
			fsm_state<=stregs1;
elsif fsm_state=bmem1 then
		PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='1'; 
		RF_wr_sel<="00"; 
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0'; 
		addr_sel<="01"; --0 kanonika alu, 01 kateythian immed,diavazw oti einai sthn MEM[immed<<2)
		reg_immed<='0';--1 register 0 immed
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=bmem2;
elsif fsm_state=bmem2 then
		PC_LdEn<='1'; 
		PC_sel<=equal;
		RF_B_sel<='1'; 
		RF_wr_sel<="00"; 
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0'; 
		addr_sel<="01"; --0 kanonika alu, 1 kateythian immed,diavazw oti einai sthn MEM[immed<<2)
		reg_immed<=equal;--1 register 0 immed
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0pc0;
elsif fsm_state=addmem1 then -------------------------------------------
		PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='1'; --monima ston rd afou tha ton xrhsimopoihsw san endiameso (afou ekei tha grapsw to apotelesma en telei)
		RF_wr_sel<="01";--mnhmh
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='1'; --zero
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='1';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=addmem2;
elsif fsm_state=addmem2 then
		PC_LdEn<='0'; 
		PC_sel<='0';
		RF_B_sel<='1'; --monima ston rd afou tha ton xrhsimopoihsw san endiameso (afou ekei tha grapsw to apotelesma en telei)
		RF_wr_sel<="11";--to krataw k exw san source oti einai sto apotelesma tou adder
		ALU_Bin_sel<='1';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='1'; --zero
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=addmem3;
elsif fsm_state=addmem3 then
		PC_LdEn<='1'; 
		PC_sel<='0';
		RF_B_sel<='1'; --monima ston rd afou tha ton xrhsimopoihsw san endiameso (afou ekei tha grapsw to apotelesma en telei)
		RF_wr_sel<="11";--to krataw k exw san source oti einai sto apotelesma tou adder
		ALU_Bin_sel<='1';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0'; --immediate
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='1';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0pc0;
elsif fsm_state=lbBO1 then
	   PC_LdEn<='1'; 
		PC_sel<='0';
		RF_B_sel<='1';
		RF_wr_sel<="01";
		ALU_Bin_sel<='1';
		ld_type_sel<='1';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='1';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0pc0;
elsif fsm_state=lbyte1 then
		PC_LdEn<='1'; 
		PC_sel<='0';
		RF_B_sel<='1';
		RF_wr_sel<="01";
		ALU_Bin_sel<='1';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='1';
		MEM_WrEn<='0';
		RF_WrEn<='1';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0pc0;
elsif fsm_state=sbyte1 then
		PC_LdEn<='1'; 
		PC_sel<='0';
		RF_B_sel<='1';
		RF_wr_sel<="00";
		ALU_Bin_sel<='1';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='1';
		MEM_dataout_sel<='0';
		MEM_WrEn<='1';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0pc0;
elsif fsm_state=load1 then
		PC_LdEn<='1'; 
		PC_sel<='0';
		RF_B_sel<='1';
		RF_wr_sel<="01";
		ALU_Bin_sel<='1';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='1';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0pc0;
elsif fsm_state=store1 then
		PC_LdEn<='1'; 
		PC_sel<='0';
		RF_B_sel<='1';
		RF_wr_sel<="00";
		ALU_Bin_sel<='1';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='1';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0pc0;
elsif fsm_state=bneq then
		PC_LdEn<='1'; 
		PC_sel<=not zero;
		RF_B_sel<='1';
		RF_wr_sel<="00";
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0pc0;
elsif fsm_state=beq then
		PC_LdEn<='1'; 
		PC_sel<=zero;
		RF_B_sel<='1';
		RF_wr_sel<="00";
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0pc0;
elsif fsm_state=im_type1 then
		PC_LdEn<='1'; 
		PC_sel<='0';
		RF_B_sel<='0';
		RF_wr_sel<="00";
		ALU_Bin_sel<='1';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='1';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0pc0;
elsif fsm_state=r_type1 then
		PC_LdEn<='1'; 
		PC_sel<='0';
		RF_B_sel<='0';
		RF_wr_sel<="00";
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='1';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0pc0;
elsif fsm_state=li_state then
		PC_LdEn<='1'; 
		PC_sel<='0';
		RF_B_sel<='0';
		RF_wr_sel<="10";
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='1';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0pc0;
elsif fsm_state=rf0pc0 then
		PC_LdEn<='0'; --na doume an vgenoun
		PC_sel<='0';
		RF_B_sel<='0';
		RF_wr_sel<="00";
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='0';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=rf0;
elsif fsm_state=rf0 then
		PC_LdEn<='0'; --na doume an vgenoun
		PC_sel<='0';
		RF_B_sel<='1';
		RF_wr_sel<="00";
		ALU_Bin_sel<='0';
		ld_type_sel<='0';
		addle_crtl<='1';
		imm_or_zero<='0';
		addr_sel<="00";
		reg_immed<='0';
		MEM_datain_sel<='0';
		MEM_dataout_sel<='0';
		MEM_WrEn<='0';
		RF_WrEn<='0';
		var_addr<="00000";
		var_addr_act<='0';
		mem_var<="00000000000000000000000000000000";
		fsm_state<=dec_stage;
else
		fsm_state<=rst;
end if;-- if katastasewn


end if; --reset end if
end process;

end Behavioral;

