----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    19:11:25 02/21/2014 
-- Design Name: 
-- Module Name:    Summer_32 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Summer_32 is
    Port ( A : in  STD_LOGIC_VECTOR (31 downto 0);
           B : in  STD_LOGIC_VECTOR (31 downto 0);
           Cin : in  STD_LOGIC;
           Sum : out  STD_LOGIC_VECTOR (31 downto 0);
           Cout : out  STD_LOGIC);
end Summer_32;

architecture Behavioral of Summer_32 is

component cladder --dilosh tou component pou vgazei ta generate k propagate simata
		port ( A : in  STD_LOGIC_VECTOR (3 downto 0);--eisodos 1ou arithmou,sw0-3
           B : in  STD_LOGIC_VECTOR (3 downto 0);--eisodos 2ou arithmou sw4-sw7
           Cin : in  STD_LOGIC;						 --eisodos carry in,btn0
           Cout : out  STD_LOGIC;					 -- carry out,led4
           Sum : out  STD_LOGIC_VECTOR (3 downto 0)); --exodos sum,led0-3
end component;

signal ct1,ct2,ct3,ct4,ct5,ct6,ct7 :std_logic;


begin

sum0: cladder
				port map(A=>A(3 downto 0),
							B=>B(3 downto 0),
							Cin=>Cin,
							Cout=>ct1,
							Sum=>Sum(3 downto 0));
							
sum1: cladder
				port map(A=>A(7 downto 4),
							B=>B(7 downto 4),
							Cin=>ct1,
							Cout=>ct2,
							Sum=>Sum(7 downto 4));
							
sum2: cladder
				port map(A=>A(11 downto 8),
							B=>B(11 downto 8),
							Cin=>ct2,
							Cout=>ct3,
							Sum=>Sum(11 downto 8));
							
sum3: cladder
				port map(A=>A(15 downto 12),
							B=>B(15 downto 12),
							Cin=>ct3,
							Cout=>ct4,
							Sum=>Sum(15 downto 12));
							
sum4: cladder
				port map(A=>A(19 downto 16),
							B=>B(19 downto 16),
							Cin=>ct4,
							Cout=>ct5,
							Sum=>Sum(19 downto 16));
							
sum5: cladder
				port map(A=>A(23 downto 20),
							B=>B(23 downto 20),
							Cin=>ct5,
							Cout=>ct6,
							Sum=>Sum(23 downto 20));
							
sum6: cladder
				port map(A=>A(27 downto 24),
							B=>B(27 downto 24),
							Cin=>ct6,
							Cout=>ct7,
							Sum=>Sum(27 downto 24));
							
sum7: cladder
				port map(A=>A(31 downto 28),
							B=>B(31 downto 28),
							Cin=>ct7,
							Cout=>Cout,
							Sum=>Sum(31 downto 28));

end Behavioral;

