----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    19:39:47 03/10/2013 
-- Design Name: 
-- Module Name:    carry_lkahd - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

--exei san exodo ta kratoumena pros to sum_unit kathos kai to Cout

entity carry_lkahd is
    Port ( P : in  STD_LOGIC_VECTOR (3 downto 0);--pernei to propagate
           G : in  STD_LOGIC_VECTOR (3 downto 0);--...to generate
           Cin : in  STD_LOGIC;--...to kratoumeno eisodou
           Cout : out  STD_LOGIC;--vgazei to kratoumeno exodou
           Csum : out  STD_LOGIC_VECTOR (2 downto 0));--...kathos kai ta kratoumena gia ton athroisth
end carry_lkahd;

architecture Behavioral of carry_lkahd is

begin
--to kratoumeno pros to proto stadio einai to Cin
Csum(0)<=G(0) or (P(0) and Cin);--kratoumeno pros 2o stadio
Csum(1)<=G(1) or (P(1) and G(0)) or (P(1) and P(0) and Cin);--...pros 3o
Csum(2)<=G(2) or (P(2) and G(1)) or (P(2) and P(1) and G(0)) or (P(2) and P(1) and P(0) and Cin);--...pros 4o
Cout<=G(3) or (P(3) and G(2)) or (P(3) and P(2) and G(1)) or (P(3) and P(2) and P(1) and G(0)) or (P(3) and P(2) and P(1) and P(0) and Cin); --kratoumeno exodou

end Behavioral;

